<?php
/* 
   Copyright 2003, 2004 John Rankin john.rankin@affinity.co.nz

   This file turns a trail page into a published book of the contents, in a
   form suitable for printing. Adds a Printable Version to each browse page.

*/
Markup('red','>links','/\[:(redirect)\s+(.*?):\]/','<em>$1s to $2</em>');

if ($action=="print" || $action=="publish") {
    $EnablePrint = 0;
    $PageTemplateFmt = "$FarmD/pub/skins/publish/print.tmpl";
    $PageCSSListFmt = array('pub/css/local.css' => '$PubDirUrl/css/local.css');
    $LastModified = strftime($TimeFmt,$Now);
    $ActionDescription = ($action=='print') ? 'last modified' : 'collection published';
    $GroupHeaderFmt = '[:include $Group.GroupPrintHeader:][:nl:]';
    $GroupFooterFmt = '[:nl:][:include $Group.GroupPrintFooter:]';
    $LinkPageExistsFmt = 
      "<a class='wikilink' href='\$PageUrl?action=print'>\$LinkText</a>";
    $LinkPageCreateFmt = 
      "<a class='createlinktext' href='\$PageUrl?action=print'>\$LinkText</a>";
    $LinkPageCreateSpaceFmt = $LinkPageCreateFmt;
    $UrlLinkTextFmt = "<cite>\$LinkText</cite> [<b>\$LinkUrl</b>]";
    $oLinkUrlFunction = $LinkFunctions['http:'];
    $LinkFunctions['http:'] = 'LinkIMapPublish';
    Markup('[[mail','<[[|',
"/\[\[mailto:([^\s$UrlExcludeChars]*[^\s.,?!$UrlExcludeChars])\s*\|\s*(.*?)\]\]/e",
      "Addressee('$2') . ' [' . 
      Keep(Makelink(\$pagename,'mailto:$1','$1'),'L') . ']'");
    Markup('<<|','<links','/&lt;&lt;\\|([^|]+)\\|&gt;&gt;/','$1');
    Markup('<|','><<|','/&lt;\\|([^|]+)\\|&gt;/','');
    Markup('^|','<links','/\\^\\|([^|]+)\\|\\^/','');
    Markup('pub','>links','/\\[:\\*?publish(nodate)?(\\s+(.*?))?:\\]/','');
    $SpaceWikiWords = 2;
    $hide = 1;
    $PDFImgFmt = '';
    if ($action=='print') $action='browse';
} 
$needle = isset($HTTP_GET_VARS['needle']) ? $HTTP_GET_VARS['needle'] : '';
if ($needle!='') {
    SDV($HandleActions['publish'],'HandleSearchPublish');
    $haystack = $HTTP_GET_VARS['haystack'];
    $pagearray = $HTTP_GET_VARS['pagearray'];
    $PrintHeaderFmt = 'Selected Search Results';
    $SearchForFmt = "<h4>$[SearchFor]</h4>";
} else {
    SDV($HandleActions['publish'],'HandlePublish');
    $include = isset($HTTP_GET_VARS['include']) ? $HTTP_GET_VARS['include'] : '';
    $PrintHeaderFmt = "<a class='wikiword' href='\$PageUrl?action=print'>\$Group: \$Name</a>";
    $SearchForFmt = '';
}
SDV($HandlePublishFmt,array(&$PageStartFmt,
                            "wiki:$GroupHeaderFmt",
                            &$PublishList,
                            "wiki:$GroupFooterFmt",
                            &$PageEndFmt));
SDV($PublishPageNotFoundFmt,'Page \'\'$Tlink\'\' does not exist.');
SDV($PublishPageUnauthorisedFmt,'Not authorised to read page \'\'$Tlink\'\'.');
SDV($PublishPageNameFmt,"<a class='wikiword' href='\$PageUrl'>\$Name</a>:");
if (isset($EnablePathInfo) && !$EnablePathInfo)
    SDV($PublishTagFmt,"<form class='publish' target='_blank' action='\$ScriptUrl' method='get'>
    \$PublishName<input type='hidden' name='pagename' value='\$PageName' />
    <input type='hidden' name='action' value='publish' />
    <input type='checkbox' name='include' value='include' />$[Include this page]
    <input type='submit' value='$[Publish]' /></form>");
SDV($PublishTagFmt,"<form class='publish' target='_blank' action='\$PageUrl' method='get'>
    \$PublishName<input type='hidden' name='action' value='publish' />
    <input type='checkbox' name='include' value='include' />$[Include this page]
    <input type='submit' value='$[Publish]' /></form>");
Markup('pub','<links','/\\[:\\*?publish(nodate)?(\\s+(.*?))?:\\]/e',
   "Keep(FmtPublishName(\$GLOBALS['PublishTagFmt'],\$pagename,'\$3'))");
Markup('pubpg','directives','/\[:publish\\s+(.*?):\]/e',
    "ValidatePublish(\$pagename,PSS('$1'))");
SDV($IncludeModifiedDate,true);
SDV($NumberPages,true);

function ValidatePublish($pagename,$publishpage) {
  global $GroupPattern,$NamePattern,$AsSpacedFunction;
  $delimiter = '/';
  if (preg_match("/^$GroupPattern([\\/.])$NamePattern\$/",
      $publishpage,$match))
      $delimiter = $match[1];
  else
      $publishpage = FmtPageName('$Group',$pagename)."/$publishpage";
  if (PageExists($publishpage)) 
      return '[:publish '.$publishpage.':]';
  else return "[[$publishpage]] not found.";
}

function FmtPublishName($fmt,$pagename,$publishpage) {
  global $PublishPageNameFmt;
  if ($publishpage) {
     $publishpage = str_replace(" ","",$publishpage);
     $r = FmtPageName($PublishPageNameFmt,$publishpage);
     $fmt = str_replace('this','that',$fmt);
  } else {
     $r = '';
     $publishpage = $pagename;
  }
  return str_replace('$PublishName',$r,FmtPageName($fmt,$publishpage));
}

function HandlePublish($pagename) {
  global $SuffixPattern,$GroupPattern,$WikiWordPattern;
  global $HandlePublishFmt,$PublishPageNotFoundFmt;
  global $include,$PageTitle,$GCount,$IncludeModifiedDate,$NumberPages;
  $trailname = $pagename;
  $trailpage = ReadPage($pagename,"read");
  if ($trailpage) {
    if (strstr($trailpage['text'],'publishnodate:]')) $IncludeModifiedDate = false;
    if (strstr($trailpage['text'],'[:*publish')) $NumberPages = false;
    $trailgroup = FmtPageName('$Group',$trailname);
    foreach(explode("\n",$trailpage['text']) as $x) {
      if (preg_match("/^T?([#*:]+)\\s*(.*)/",$x,$match)) {
          $match[1] = str_replace(':#',':',$match[1]);
          $match[2] = 
          preg_replace("/^(($GroupPattern([\\.]))?$WikiWordPattern)/",
           '[[$2]]',$match[2]);
          if (preg_match("/(\\[\\[(.*?)\\]\\]($SuffixPattern))/",
      $match[2],$m)) {
            $depth[] = strlen($match[1]);
            $pages[] = MakeLink($trailname,$m[2],NULL,NULL,'$PageName');
            $links[] = $m[1];
          } elseif (!strstr($match[1],":")) {
            $depth[] = strlen($match[1]);
            $pages[] = "textonly";
            $links[] = $match[2];
          }
      }
    }
    if ($include!='') {
        $PublishList[] = "function:PrintThisPage $pagename";
    }
    $counter = array(); $predepth= 0; $counter[0] = 0;
    for($i=0;$i<count($pages);$i++) {
      $counter[$depth[$i]-1]++;
      $num = $counter[0];
      for($j=$depth[$i];$j<$predepth;$j++) $counter[$j] = 0;
      $predepth = $depth[$i];
      $size = 0;
      for($j=1;$j<$depth[$i];$j++) { $num .= "." . $counter[$j]; $size++; }
      if ($size>3) $size=3;
      $num = $NumberPages ? "$num " : '';
      $s = str_repeat('-',$size);
      $PublishList[] = "<div class='pagehead$depth[$i]'>";
      if ($size==0) $PublishList[] = "markup:!$num$links[$i]";
      else $PublishList[] = "markup:![$s$num$links[$i]$s]";
      $PublishList[] ='</div>';
      if ($pages[$i]!="textonly") {
          if (PageExists($pages[$i])) 
	       	  $PublishList[] = "function:PrintThisPage $pages[$i]";
          else {
              $replname = MakeLink($trailname,$links[$i],NULL,NULL,'$LinkText');
              if (MakeLink($trailname,"[[$replname]]",NULL,NULL,'$PageName')==$pages[$i])
                $replname = $links[$i];
              else $replname = "[[".$pages[$i]."]] ($replname)";
              $PublishList[] = 
                  "markup:" . 
                  str_replace('$Tlink',$replname,$PublishPageNotFoundFmt);
          }
      }
    }
  }
  $GLOBALS['PublishList'] = $PublishList;
  $PageTitle = "Publish $pagename"; $GCount = 0;
  PrintFmt($pagename,$HandlePublishFmt);
}

function HandleSearchPublish($pagename) {
  global $HandlePublishFmt,$HTMLTitle,$GCount;
  global $needle,$haystack,$pagearray;
  for($i=0;$i<count($pagearray);$i++) {
    $page = str_replace('/','/{{',$pagearray[$i]) . "}}";
    $PublishList[] = "markup:!$page";
    $PublishList[] = "function:PrintThisPage $pagearray[$i]";
  }
  if (count($pagearray)==0) $PublishList[] = "<h3>$[No pages selected]</h3>";
  $GLOBALS['PublishList'] = $PublishList;
  $GLOBALS['Needle'] = $needle;
  $GLOBALS['Haystack'] = $haystack;
  $HTMLTitle = "Publish Search"; $GCount = 0;
  PrintFmt($pagename,$HandlePublishFmt);
}

function NeedleAndHaystack($pagename) {
  global $SearchIncl,$SearchExcl,$SearchGroup;
  global $Needle,$HackNeedle,$Haystack,$Search,$SearchResults;
  if ($SearchGroup) { $Haystack = "&lsquo;$SearchGroup&rsquo; group"; }
  else { $Haystack = 'all groups'; }
  if (!$Search['text']) { 
      $Needle= 'nothing';
      $GLOBALS['MatchCount'] = 0;
      $GLOBALS['MatchSearched'] = 0;
      return;
  }
  if ($GLOBALS['MatchCount']==0) $SearchResults = '<em>No matches.</em>';
  $n = str_replace('$LQ$RQ',"",'$LQ'.join('$RQ and $LQ',$SearchIncl).'$RQ');
  foreach($SearchExcl as $w) { $n .= " not \$LQ$w\$RQ"; }
  if ($n) $Needle = str_replace('$LQ','&lsquo;',
                    str_replace('$RQ','&rsquo;',htmlspecialchars(trim($n))));
  else $Needle = 'all';
  $HackNeedle = $Needle;
}

function PrintText($pagename,$text) {
  echo MarkupToHTML($pagename,$text);
}

function PrintThisPage($pagename,$wikipage=NULL) {
  global $IncludeModifiedDate,$PublishPageUnauthorisedFmt,$TimeFmt;
  if (is_null($wikipage)) $wikipage=$pagename;
  $page = RetrieveAuthPage($wikipage,"read",false);
  if ($page) {
    $GLOBALS['pagename'] = $wikipage;
    SetInterMapUrls($wikipage);
    echo MarkupToHTML($wikipage,$page['text']);
    if ($IncludeModifiedDate) echo MarkupToHTML($wikipage,"\n\n(".strftime($TimeFmt,$page['time']).")");
    $GLOBALS['pagename'] = $pagename;
  } else echo MarkupToHTML($wikipage,
            str_replace('$Tlink',$wikipage,$PublishPageUnauthorisedFmt));
}

function SetInterMapUrls($page) {
  global $UploadUrlFmt,$UploadPrefixFmt,$InterMapUrls;
  $InterMapUrls['Attach'] = 
        FmtPageName("$UploadUrlFmt$UploadPrefixFmt$1",$page);
}
/*
function PrepareText($pagename,$text) {
  global $GroupPattern,$NamePattern,$MaxIncludes,$BrowseDirectives;
  $inclcount=0;
  while ($inclcount<$MaxIncludes &&
      preg_match("/\\[:include (.*?)(?:(#.*?)(#.*?)?)?:\\]/",$text,$match)) {
    list($inclrepl,$inclname,$fran,$toan) = $match; $incltext='';
    if (!preg_match("/^$GroupPattern([\\/.])$NamePattern\$/",
        $inclname))
      $inclname = FmtPageName('$Group',$pagename).".$inclname";
    $inclpage = RetrieveAuthPage($inclname,"read",false);
    if ($inclpage) {
        $incltext=$inclpage['text'];
        if ($toan!='') {
            $franch = "[[$fran]]"; $toanch = "[[$toan]]";
            $incltext = substr($incltext,0,strpos($incltext.$toanch,$toanch));
            if (strstr($incltext,$franch)) $incltext = 
str_replace(substr($incltext,0,strpos($incltext,$franch)).$franch,'',$incltext);
        } elseif ($fran!='' && preg_match("/\\[\\[$fran\\]\\]\\n?(.*?)\\n/", $incltext."\n", $p)) 
                  $incltext = $p[1];
    }
    $text = str_replace($inclrepl,$incltext,$text);
    $inclcount++;
  }
  Lock(0);
#  foreach($BrowseDirectives as $p=>$s) {
#    if (strstr($text,$p)) $text = str_replace($p,eval($s),$text);
#  }
  return $text;
}
*/
function PrintEndnotes($pagename,$urltext) {
  $etext = Endnote('',$urltext);
  if ($etext!="") 
        echo MarkupToHTML($pagename,str_replace('http://','',$etext));
}

function Endnote($imap,$urltext) {
  static $endcount, $endtext;
  if ($urltext == "#") {
     $r = "$endtext";
     if ($endcount>0) $r = "!Links\n$r";
     $endcount = 0;
     $endtext = '';
  } else {
     $endcount++;
     $r = "<a href='#end$endcount'>$endcount</a>";
     $urltext = str_replace('&amp;','&',stripslashes($urltext));
     $endtext .= "# [[#end$endcount]] $imap$urltext\n";
  }
  return $r;
}
/*
function FmtUrlLinkPublish($pat,$ref,$btext) {
  global $SaveFmtUrlLink;
  if (!is_null($btext)) { $ref = Endnote($ref); }
  return $SaveFmtUrlLink($pat,$ref,$btext);
}
*/
function LinkIMapPublish($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
  global $ImgExtPattern,$UrlLinkTextFmt,$oLinkUrlFunction;
  if (strstr("$imap$path",$txt) || preg_match("/$ImgExtPattern\$/",$path)) 
      return $oLinkUrlFunction($pagename,$imap,$path,$title,$txt,$fmt);
  return str_replace('$LinkUrl',Endnote($imap,$path),
            str_replace('$LinkText',$txt,$UrlLinkTextFmt));
}

function Addressee($name) {
  global $WikiWordPattern;
  $r = preg_replace("/($WikiWordPattern)/","`$1",$name);
  return "<em>$r</em>";
}

?>
